unit MIMETypes;

interface


  //   MIME     
  function MimeTypeByFileExt(const FileName: string): string;


implementation

uses
  KOL;

const
  MimeTypesArray: array [0..40] of
    record
      E: string;
      MT: string;
    end =
  (
    (E: '.7z'; MT: 'application/x-7z-compressed'),
    (E: '.aac'; MT: 'audio/aac'),
    (E: '.avi'; MT: 'video/avi'),
    (E: '.bmp'; MT: 'image/bmp'),
    (E: '.cab'; MT: 'application/vnd.ms-cab-compressed'),
    (E: '.css'; MT: 'text/css'),
    (E: '.csv'; MT: 'text/csv'),
    (E: '.doc'; MT: 'application/msword'),
    (E: '.flac'; MT: 'audio/x-flac'),
    (E: '.flv'; MT: 'video/x-flv'),
    (E: '.gif'; MT: 'image/gif'),
    (E: '.gz'; MT: 'application/x-gzip-compressed'),
    (E: '.htm'; MT: 'text/html'),
    (E: '.html'; MT: 'text/html'),
    (E: '.ico'; MT: 'image/vnd.microsoft.icon'),
    (E: '.jpg'; MT: 'image/jpeg'),
    (E: '.jpeg'; MT: 'image/jpeg'),
    (E: '.js'; MT: 'application/x-javascript'),
    (E: '.mid'; MT: 'audio/midi'),
    (E: '.mkv'; MT: 'application/x-matroska'),
    (E: '.mov'; MT: 'video/quicktime'),
    (E: '.mp3'; MT: 'audio/mpeg3'),
    (E: '.mp4'; MT: 'video/mp4'),
    (E: '.mpg'; MT: 'video/mpeg'),
    (E: '.mpeg'; MT: 'video/mpeg'),
    (E: '.pdf'; MT: 'application/pdf'),
    (E: '.png'; MT: 'image/png'),
    (E: '.rar'; MT: 'application/x-rar-compressed'),
    (E: '.rtf'; MT: 'text/richtext'),
    (E: '.svg'; MT: 'image/svg+xml'),
    (E: '.swf'; MT: 'application/x-shockwave-flash'),
    (E: '.tar'; MT: 'application/x-tar'),
    (E: '.tif'; MT: 'image/tiff'),
    (E: '.tiff'; MT: 'image/tiff'),
    (E: '.txt'; MT: 'text/plain'),
    (E: '.wav'; MT: 'audio/wav'),
    (E: '.wma'; MT: 'audio/x-ms-wma'),
    (E: '.wmf'; MT: 'image/x-wmf'),
    (E: '.xls'; MT: 'application/x-excel'),
    (E: '.xml'; MT: 'text/xml'),
    (E: '.zip'; MT: 'application/zip')
  );

function MimeTypeByFileExt(const FileName: string): string;
var
  Ext: string;
  I: Integer;
begin
  Result := 'application/octet-stream';
  
  Ext := ExtractFileExt(FileName);
  if Ext = '' then Exit;
  
  Ext := LowerCase(Ext);

  for I := 0 to High(MimeTypesArray) do
  begin
    if MimeTypesArray[I].E = Ext then
    begin
      Result := MimeTypesArray[I].MT;
      Exit;
    end;
  end;
end;

end.